use crate::hash::hash_u32;

/// Performs a base-2 Owen scramble on an integer.
pub fn owen(n: u32, seed: u32) -> u32 {
    let mut result = n;

    for b in 0..31 {
        let mask = (!0) << (b + 1);
        result ^= hash_u32(n & mask, seed) & (1 << b);
    }
    result ^= hash_u32(0, seed) & (1 << 31); // Handle highest bit.

    result
}
